package jp.wda.gpss.system.seasar;

import java.io.File;

import jp.wda.gpss.system.Configuration;
import jp.wda.gpss.system.Main;
import jp.wda.gpss.system.SystemCommander;

import org.seasar.system.Lifecycle;
import org.seasar.util.SeasarException;

/**
 * SeasarT[rXvOC<BR>
 * <BR>
 * homevpeB̒lɁAGPSSz[fBNgւ̃pXw肵ĂB<BR>
 * ΃pXw肵ꍇ́Aseasar.homȇ΂ɂȂ܂B<BR>
 * configvpeB̒lɁAconfig.xmlݒt@Cw肵ĂB<BR>
 * <BR>
 * homevpeBݒ肷ꍇ́AKconfigvpeB̑Oɐݒ肵ĂB
 *
 * @version	1.04		2003/11/27
 * @since		1.04		2003/11/27
 * @author	amoi
 */
public final class GPSSService implements Lifecycle {
	// RXgN^ ///////////////////////////////////////////////////////////////////
	//                                                                    Constructors //
	/////////////////////////////////////////////////////////////////////////////////////

	/* ***********************************************************************>> */;
	/**
	 *	ftHg̐ݒpăIuWFNg\zRXgN^
	 */
	public GPSSService(){
		super();
	}

	// tB[h` ///////////////////////////////////////////////////////////////
	//                                                                          Fields //
	/////////////////////////////////////////////////////////////////////////////////////

	/* ***********************************************************************>> */;
	/**
	 * GPSSNݒ
	 */
	private Configuration configuration = null;

	// vpeB ///////////////////////////////////////////////////////////////////////
	//                                                                      Properties //
	/////////////////////////////////////////////////////////////////////////////////////

	/* ***********************************************************************>> */;
	/**
	 *	GPSSRtBM[Vt@C<BR>
	 */
	private String _config = null;
	/**
	 *	GPSSRtBM[Vt@C擾<BR>
	 *	@return GPSSRtBM[Vt@C
	 */
	public String getConfig(){ return _config; }
	/**
	 *	GPSSRtBM[Vt@Cݒ肷<BR>
	 *	@param s ݒl<BR>
	 */
	public void setConfig(String s) throws SeasarException{
		File configfile = new File(s);
		if(!configfile.isAbsolute()){
			configfile = new File(System.getProperty("seasar.home") + File.separator + s);
		}
		this._config = configfile.getAbsolutePath();
		this.configuration = new Configuration(configfile);
		try{
			this.configuration.loadConfig();
		}catch(Exception e){
			throw new SeasarException("ESR001");
		}
	}

	/* ***********************************************************************>> */;
	/**
	 *	GPSSz[fBNg<BR>
	 */
	private String _gpss_home = null;
	/**
	 *	GPSSz[fBNg擾<BR>
	 *	@return GPSSz[fBNg
	 */
	public String getHome(){ return _gpss_home; }
	/**
	 *	GPSSz[fBNgݒ肷<BR>
	 *	@param s ݒl<BR>
	 */
	public void setHome(String s){
		File home = new File(s);
		if(!home.isAbsolute()){
			home = new File(new File(System.getProperty("seasar.home")), s);
		}
		this._gpss_home = home.getAbsolutePath();
		System.setProperty("gpss.home", this._gpss_home);
	}

	// I[@[Ch /////////////////////////////////////////////////////////////////
	//                                                               Over Ride Methods //
	/////////////////////////////////////////////////////////////////////////////////////

	/* ***********************************************************************>> */;
	/**
	 * SeasarT[rXJn܂B
	 */
	public void start() throws SeasarException {
		System.out.println("GPSST[rXJn܂B");
		new GPSSStarter(_config).start();
	}

	/* ***********************************************************************>> */;
	/**
	 * SeasarT[rXI܂B
	 */
	public void stop() throws SeasarException {
		SystemCommander.main(new String[]{ "" + this.configuration.getPort(), "shutdown" });
	}
	
	// NX ///////////////////////////////////////////////////////////////////////
	//                                                                     Inner Class //
	/////////////////////////////////////////////////////////////////////////////////////
	private class GPSSStarter extends Thread{
		private String _config = null;
	
		GPSSStarter(String config){ this._config = config; }
		public final void run() { Main.main(new String[]{ _config }); }
	}
}

